{-# LANGUAGE FlexibleInstances, MultiParamTypeClasses
  , OverlappingInstances, UndecidableInstances #-}

{- |

Easier, but less safe version of WXForm. It includes WxForm, but also
makes every type an instance of 'TypePresentation' and
'GInstanceCreator'.

This means that the module uses both -fallow-undecidable-instances and
-fallow-overlapping-instances.

-}
module Graphics.UI.AF.WxFormAll
    ( module Graphics.UI.AF.WxForm
    )
where

import Graphics.UI.AF.WxForm

import Graphics.UI.AF.WxForm.WxFormImplementation
import Graphics.UI.AF.General.AutoForm (TypePresentation)
import Graphics.UI.AF.General.InstanceCreator

instance (Data ECCreatorD a, GInstanceCreator a, Show a, TypePresentation a WxAct ComH WxM ECCreatorD EC)
    => ECCreator a
instance TypePresentation a action comH builder satCxt com
-- instance TypePresentation a context

{- Instead of this unsafe choice, we could make our own 'derive
template and let it derive ECCreator, Show, ...

But we would need to let the user use the SYB derive, so that he could
override stuff when needed. -}
